%define anolis_release 1

%global         debug_package %{nil}

Summary:        Pure-Python library for parsing and analyzing ELF files
Name:           pyelftools
Version:        0.30
Release:        %{anolis_release}%{?dist}
License:        Public Domain
URL:            https://github.com/eliben/pyelftools
Source0:        https://github.com/eliben/pyelftools/archive/v%{version}/%{name}-%{version}.tar.gz
%global _description \
Pure-Python library for parsing and analyzing ELF files\
and DWARF debugging information.
%description   %_description

%package     -n python3-%{name}
Summary:        %{summary}
# https://github.com/eliben/pyelftools/issues/180
Provides:       bundled(python3-construct) = 2.6
BuildRequires:  %{_bindir}/llvm-dwarfdump
BuildRequires:  %{_bindir}/readelf
BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
BuildArch:      noarch
%{?python_provide:%python_provide python3-%{name}}
%description -n python3-%{name} %_description

%package -n     python3-%{name}-doc
Summary:        doc files for python3-%{name}
Requires:       python3-%{name} = %{version}-%{release}

%description -n python3-%{name}-doc
doc files for python3-%{name}

%prep
%autosetup
%ifnarch x86_64
rm test/external_tools/llvm-dwarfdump
rm test/external_tools/readelf
%endif

%build
%{py3_build}

%install
%{py3_install}
pushd %{buildroot}%{_bindir}
mv readelf.py pyreadelf-%{python3_version}
ln -s pyreadelf-%{python3_version} pyreadelf-3
ln -s pyreadelf-3 pyreadelf
popd

%check
%{__python3} test/run_all_unittests.py
%{__python3} test/run_examples_test.py
# tests may fail because of differences in output-formatting
# from binutils' readelf.  See:
# https://github.com/eliben/pyelftools/wiki/Hacking-guide#tests
%{__python3} test/run_readelf_tests.py || :

%files -n python3-%{name}
%license LICENSE
%{_bindir}/pyreadelf
%{_bindir}/pyreadelf-%{python3_version}
%{_bindir}/pyreadelf-3
%{python3_sitelib}/elftools
%{python3_sitelib}/pyelftools-*.egg-info

%files -n python3-%{name}-doc
%doc CHANGES

%changelog
* Wed Apr  3 2024 Wenlong Zhang <zhangwenlong@loongson.cn> - 0.30-1
- update to 0.30

* Wed Mar 27 2024 Bo Ren <rb01097748@alibaba-inc.com> - 0.29-2
- Rebuild with python3.11

* Fri Sep 01 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.29-1
- Init upstream from version 0.29
